/*
 * Camisa.java
 *
 * Created on 29 de Setembro de 2006, 13:52
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package classes;

import java.awt.Color;
import java.util.Collection;
import java.util.Comparator;
import java.util.HashSet;
import java.util.Set;
import javax.swing.Icon;
import javax.swing.ImageIcon;

/**
 *
 * @author vitor
 */
public class Camisa {
    private String modelo;
    private Character tamanho;
    private Color cor;
    private Double preco;
    private Icon foto;
    private Boolean babyLook;
    
    /** Creates a new instance of Camisa */
    public Camisa(String modelo, Character tamanho, Color cor, Double preco, Icon foto, Boolean babyLook) {
        this.setModelo(modelo);
        this.setTamanho(tamanho);
        this.setCor(cor);
        this.setPreco(preco);
        this.setFoto(foto);
        this.setBabyLook(babyLook);
    }

    public String getModelo() {
        return modelo;
    }

    public void setModelo(String modelo) {
        this.modelo = modelo;
    }

    public Character getTamanho() {
        return tamanho;
    }

    public void setTamanho(Character tamanho) {
        this.tamanho = tamanho;
    }

    public Color getCor() {
        return cor;
    }

    public void setCor(Color cor) {
        this.cor = cor;
    }

    public Double getPreco() {
        return preco;
    }

    public void setPreco(Double preco) {
        this.preco = preco;
    }


    public Icon getFoto() {
        return foto;
    }

    public void setFoto(Icon foto) {
        this.foto = foto;
    }

    public Boolean getBabyLook() {
        return babyLook;
    }

    public void setBabyLook(Boolean babyLook) {
        this.babyLook = babyLook;
    }
    
    public static Collection<Camisa> listProdutos() {
        Set<Camisa> produtos = new HashSet<Camisa>();
        
        Icon camisaBinary = new ImageIcon(Camisa.class.getResource("/resources/fotos/camisaBinary.jpg"));
        Icon camisaCaffeine = new ImageIcon(Camisa.class.getResource("/resources/fotos/camisaCaffeine.jpg"));
        Icon camisaFix = new ImageIcon(Camisa.class.getResource("/resources/fotos/camisaFix.jpg"));
        Icon camisaLocalhost = new ImageIcon(Camisa.class.getResource("/resources/fotos/camisaLocalhost.jpg"));
        Icon camisaPi = new ImageIcon(Camisa.class.getResource("/resources/fotos/camisaPi.jpg"));
        Icon camisaRoot = new ImageIcon(Camisa.class.getResource("/resources/fotos/camisaRoot.jpg"));
        
        produtos.add(new Camisa("Caffeine Molecule", 'P', Color.BLUE, 14.99, camisaCaffeine, false));
        produtos.add(new Camisa("Caffeine Molecule", 'M', Color.BLUE, 14.99, camisaCaffeine, false));
        produtos.add(new Camisa("Caffeine Molecule", 'G', Color.BLUE, 14.99, camisaCaffeine, false));
        produtos.add(new Camisa("Caffeine Molecule", 'M', Color.BLUE, 14.99, camisaCaffeine, true));
        produtos.add(new Camisa("Caffeine Molecule", 'G', Color.BLUE, 14.99, camisaCaffeine, true));
        produtos.add(new Camisa("No, I will not fix your computer", 'P', Color.BLACK, 17.99, camisaFix, false));
        produtos.add(new Camisa("No, I will not fix your computer", 'P', Color.WHITE, 17.99, camisaFix, false));
        produtos.add(new Camisa("No, I will not fix your computer", 'P', Color.WHITE, 17.99, camisaFix, true));
        produtos.add(new Camisa("No, I will not fix your computer", 'M', Color.BLACK, 17.99, camisaFix, false));
        produtos.add(new Camisa("No, I will not fix yomur computer", 'M', Color.WHITE, 17.99, camisaFix, false));
        produtos.add(new Camisa("No, I will not fix your computer", 'M', Color.WHITE, 17.99, camisaFix, true));
        produtos.add(new Camisa("Binary People", 'P', Color.BLACK, 15.99, camisaBinary, false));
        produtos.add(new Camisa("Binary People", 'M', Color.BLACK, 15.99, camisaBinary, false));
        produtos.add(new Camisa("Binary People", 'M', Color.BLACK, 15.99, camisaBinary, true));
        produtos.add(new Camisa("There's no place like 127.0.0.1", 'P', Color.BLACK, 13.99, camisaLocalhost, false));
        produtos.add(new Camisa("There's no place like 127.0.0.1", 'M', Color.BLACK, 13.99, camisaLocalhost, false));
        produtos.add(new Camisa("There's no place like 127.0.0.1", 'M', Color.BLACK, 13.99, camisaLocalhost, true));
        produtos.add(new Camisa("Pi By Numbers", 'P', Color.BLUE, 14.99, camisaPi, false));
        produtos.add(new Camisa("Pi By Numbers", 'M', Color.BLUE, 14.99, camisaPi, false));
        produtos.add(new Camisa("Pi By Numbers", 'M', Color.BLUE, 14.99, camisaPi, true));
        produtos.add(new Camisa("got root?", 'P', Color.BLACK, 16.99, camisaRoot, false));
        produtos.add(new Camisa("got root?", 'M', Color.BLACK, 16.99, camisaRoot, false));
        produtos.add(new Camisa("got root?", 'M', Color.BLACK, 16.99, camisaRoot, true));
        
        return produtos;
    }
    
    public static class ComparadorModelo implements Comparator<Camisa> {
        public int compare(Camisa o1, Camisa o2) {
            return o1.getModelo().compareTo(o2.getModelo());
        }
    }
    public static class ComparadorTamanho implements Comparator<Camisa> {
        public int compare(Camisa o1, Camisa o2) {
            return o1.getTamanho().compareTo(o2.getTamanho());
        }
    }
    public static class ComparadorPreco implements Comparator<Camisa> {
        public int compare(Camisa o1, Camisa o2) {
            return o1.getPreco().compareTo(o2.getPreco());
        }
    }
}
